#ifndef CROPPINGMASK_H
#define CROPPINGMASK_H

#include <QDialog>
#include <QTimer>
#include <sandboxSetup.h>
#include <opencv2/opencv.hpp>
#include "qtfullscreen.h"
#include "maskedit.h"
#include "monitorgui.h"
#include "subapp.h"

namespace Ui {
class CroppingMask;
}

class CroppingMask : public SubApp
{
    Q_OBJECT

public:
    explicit CroppingMask(SandboxSetup *sandbox, MonitorGui *_mg, QWidget *parent = 0);
    ~CroppingMask();
    std::vector<cv::Point> getRectPoints(){ return rectPoints; };
    void valideRoutine();
    void cancelRoutine();

protected:
    void showEvent(QShowEvent *event);
    void closeEvent(QCloseEvent *event);

private:
    Ui::CroppingMask *ui;
    SandboxSetup *setup;
    std::vector<cv::Point> rectPoints;
    cv::Mat cameraColoredFrame;
    MaskEdit *maskEdit;
    MonitorGui *mg;
    QtFullScreen *blueScreen;
    bool blueScreenInitilized = false;
    bool maskUpdated = false;
    QTimer *timer;

    bool maskValideInFrame(cv::Mat *rgb);
    void refreshFrame();
    void init();
};

#endif // CROPPINGMASK_H
