#ifndef INITCAMERA_H
#define INITCAMERA_H

#include <QWidget>
#include <QTimer>
#include <QThread>
#include "subapp.h"
#include <sandboxSetup.h>

namespace Ui {
class InitCamera;
}


class CameraStartThread : public QThread
{
    Q_OBJECT

public:
    explicit CameraStartThread(Camera *c);
    void run();

signals:
    void setupReady(int err);

private:
    Camera *camera;
};



class InitCamera : public SubApp
{
    Q_OBJECT

public:
    explicit InitCamera(SandboxSetup *_setup, QWidget *parent = 0);
    ~InitCamera();

protected:
    void showEvent(QShowEvent *event);

private:
    Ui::InitCamera *ui;
    SandboxSetup *setup;
    CameraStartThread *workerThread;

    void setupCamera();
    void setupReady(int err);
};

#endif // INITCAMERA_H
