#include "qtfullscreen.h"

QtFullScreen::QtFullScreen(QRect reso, bool _isBorderless, QWidget *parent) : QDialog(parent)
{
    image = new QLabel(this);
    image->setScaledContents(true);
    resolution = new QRect(reso.left(), reso.top(), reso.width(), reso.height());
    isBorderless = _isBorderless;
    this->setAttribute(Qt::WA_ShowWithoutActivating);
    editGeometry(*resolution);
}

QtFullScreen::~QtFullScreen()
{
    delete resolution;
    delete image;
}

void QtFullScreen::editGeometry(QRect reso){
    editGeometry(reso.x(), reso.y(), reso.width(), reso.height());
}


void QtFullScreen::editGeometry(int x, int y, int w, int h){
    this->setGeometry(x, y, w, h);
    image->setGeometry(0 , 0, w, h);
}

void QtFullScreen::imShow(cv::Mat frame){

    QImage src = QImage((uchar *)frame.data, (int)frame.cols, (int)frame.rows, static_cast<int>(frame.step.buf[0]), QImage::Format_RGB888);
    QPixmap px = QPixmap::fromImage(src);
    image->setPixmap(px);

    if(!this->isVisible()){
        if(isBorderless){
            this->showFullScreen();
        }else{
            this->show();
        }
    }
}
