#ifndef BEAMERPROJECTION_H
#define BEAMERPROJECTION_H

#include <opencv2/opencv.hpp>
#include "beamer.h"
#include "camera.h"

class BeamerProjection{
    private:
        cv::Mat adjustingMatrix;
        float distanceTopSandbox = 1.0f;

        cv::Point2i findMatchingPixel(int i, int j, float z, Camera *camera, cv::Point3f beamer_pos);
        void copyPixelsInto(cv::Point2i pixel_dst, cv::Mat &dst, cv::Point2i pixel_src, cv::Mat &src, cv::Rect base);
        cv::Size getMatchingSize(cv::Mat &src, cv::Rect base);

    public:
        BeamerProjection();

        void setAdjustingMatrix(cv::Mat matrix){ adjustingMatrix = matrix; }
        cv::Mat getAdjustingMatrix(){ return adjustingMatrix; }
        void setDistanceTopSandbox(float dist){ distanceTopSandbox = dist; };
        float getDistanceTopSandbox(){ return distanceTopSandbox; };

        cv::Point2i rotatePixel(cv::Point2i pixel);
        void adjustFrame(cv::Mat depth, cv::Mat src, cv::Mat &dst, Camera *camera, cv::Point3f beamer_pos);
        void printAdjustingMatrix();

};
#endif