#ifndef SANDBOX_H
#define SANDBOX_H

#include <opencv2/opencv.hpp>
#include "camera.h"
#include "beamerProjection.h"
#include "beamer.h"
#include "sandboxConfig.h"

class Sandbox{
    private:
        char *defaultConfigFilePath = (char *)"./sandbox_conf.yaml";
        char *defaultWindowsName = (char*) "ShowApp";
        BeamerProjection projection;
        Camera camera;
        Beamer beamer;

        void initWindowsFullScreen(char *windowName);
        void showImage(cv::Mat* image, char *windowName);

    public:
        Sandbox();

        Camera* getCamera(){ return &camera; };
        Beamer* getBeamer(){ return &beamer; };
        BeamerProjection* getProjection(){ return &projection; };

        void init();
        cv::Mat getColorFrame();
        cv::Mat getDepthFrame();
        cv::Mat adjustProjection(cv::Mat frame);
        void showImage(cv::Mat &image);
        int loadConfig();
        int loadConfigFrom(char *path);
        void initWindowsFullScreen();
    
};

#endif
